commit:     db7583610d5078d645d7f55ca80b181763c43273
Author:     Juanjie Xi <strangemk3 <AT> gmail <DOT> com>
AuthorDate: Fri Dec 22 02:09:18 2017 +0000
Commit:     Patrice Clement <monsieurp <AT> gentoo <DOT> org>
CommitDate: Fri Jan 26 21:47:58 2018 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=db758361

app-misc/tmux: add patch against the pipe-pane unreliable bug.

Closes: https://bugs.gentoo.org/640228
Closes: https://github.com/gentoo/gentoo/pull/6596
Package-Manager: Portage-2.3.13

 app-misc/tmux/files/tmux-2.3-pipe_pane-fix.patch |  9 +++
 app-misc/tmux/tmux-2.3-r2.ebuild                 | 91 ++++++++++++++++++++++++
 2 files changed, 100 insertions(+)

diff --git a/app-misc/tmux/files/tmux-2.3-pipe_pane-fix.patch 
b/app-misc/tmux/files/tmux-2.3-pipe_pane-fix.patch
new file mode 100644
index 00000000000..65dd2f3c1bc
--- /dev/null
+++ b/app-misc/tmux/files/tmux-2.3-pipe_pane-fix.patch
@@ -0,0 +1,9 @@
+--- a/window.c 2016-09-29 05:31:24.000000000 +0800
++++ b/window.c 2017-12-22 09:38:43.709617000 +0800
+@@ -981,7 +981,7 @@
+
+       input_parse(wp);
+
+-      wp->pipe_off = size;
++      wp->pipe_off = EVBUFFER_LENGTH(evb);
+ }

diff --git a/app-misc/tmux/tmux-2.3-r2.ebuild b/app-misc/tmux/tmux-2.3-r2.ebuild
new file mode 100644
index 00000000000..3bed9128b2f
--- /dev/null
+++ b/app-misc/tmux/tmux-2.3-r2.ebuild
@@ -0,0 +1,91 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit autotools flag-o-matic versionator
+
+DESCRIPTION="Terminal multiplexer"
+HOMEPAGE="http://tmux.github.io/";
+SRC_URI="https://github.com/${PN}/${PN}/releases/download/${PV}/${P}.tar.gz";
+
+LICENSE="ISC"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh 
~sparc ~x86 ~amd64-fbsd ~x86-fbsd ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos 
~x86-macos"
+IUSE="debug selinux utempter vim-syntax kernel_FreeBSD kernel_linux"
+
+CDEPEND="
+       >=dev-libs/libevent-2.1.5-r4:=
+       utempter? (
+               kernel_linux? ( sys-libs/libutempter )
+               kernel_FreeBSD? ( || ( >=sys-freebsd/freebsd-lib-9.0 
sys-libs/libutempter ) )
+       )
+       sys-libs/ncurses:0="
+
+DEPEND="
+       ${CDEPEND}
+       virtual/pkgconfig"
+
+RDEPEND="
+       ${CDEPEND}
+       selinux? ( sec-policy/selinux-screen )
+       vim-syntax? (
+               || (
+                       app-editors/vim
+                       app-editors/gvim
+               )
+       )"
+
+PATCHES=(
+       "${FILESDIR}"/${PN}-2.3-flags.patch
+
+       # usptream fixes (can be removed with next version bump)
+       "${FILESDIR}"/${P}-screen_write_copy-fix.patch
+       "${FILESDIR}"/${P}-pipe_pane-fix.patch
+)
+
+src_prepare() {
+       default
+
+       # regenerate aclocal.m4 to support earlier automake versions
+       rm aclocal.m4 || die
+
+       eautoreconf
+}
+
+src_configure() {
+       # bug 438558
+       # 1.7 segfaults when entering copy mode if compiled with -Os
+       replace-flags -Os -O2
+
+       econf \
+               --sysconfdir="${EPREFIX}"/etc \
+               $(use_enable debug) \
+               $(use_enable utempter)
+}
+
+src_install() {
+       default
+
+       dodoc example_tmux.conf
+       docompress -x /usr/share/doc/${PF}/example_tmux.conf
+
+       if use vim-syntax; then
+               insinto /usr/share/vim/vimfiles/ftdetect
+               doins "${FILESDIR}"/tmux.vim
+       fi
+}
+
+pkg_postinst() {
+       if ! version_is_at_least 1.9a ${REPLACING_VERSIONS:-1.9a}; then
+               ewarn
+               ewarn "Some configuration options changed in this release."
+               ewarn "Please read the CHANGES file in /usr/share/doc/${PF}/"
+               ewarn
+               ewarn "WARNING: After updating to ${P} you will _not_ be able 
to connect to any"
+               ewarn "older, running tmux server instances. You'll have to use 
an existing client to"
+               ewarn "end your old sessions or kill the old server instances. 
Otherwise you'll have"
+               ewarn "to temporarily downgrade to access them."
+               ewarn
+       fi
+}

Reply via email to